package whdghks913.tistory.examplenofitication;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Notification;
import android.app.Notification.BigPictureStyle;
import android.app.Notification.InboxStyle;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v4.app.NotificationCompat;
import android.view.View;
import android.widget.RemoteViews;

@SuppressLint("NewApi")
public class MainActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }
    
    public void nomal_notification(View v){
        /**
         * API ̵ (http://developer.android.com/reference/android/app/Notification.html)
         * 
         * Notification notification = new Notification(icon, tickerText, when);
         * icon : 
         * tickerText : 
         * when : ˸ ǥ ð
         * 
         * notification.setLatestEventInfo(context, contentTitle, contentText, contentIntent);
         * context : ؽƮ ü
         * contentTitle : notification ǥõ 
         * contentText : notification ǥõ 
         * contentIntent : ˸ ġ  ۾
         * 
         * PendingIntent contentIntent = PendingIntent.getActivity(context, requestCode, intent, flags);
         * context : ؽƮ ü
         * requestCode : ûڵ
         * intent : ó ۾ ԵǾ ִ intentü
         * flags : Ÿ  ɼ
         * 
         * nm.notify(id, notification)
         * id: ˸  
         * notification : notification ü
         */
        
        // ˸ ý  Դϴ ý 񽺸 ȣմϴ
        NotificationManager nm = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
        
        // ܰ  ǥõ ޼ ǥմϴ  "ο ޼ ߽ϴ"
        //  System.currentTimeMillis() ˸ ǥ ðԴϴ  иʸ ȯϿ ٷ ˸ ǥմϴ
        Notification notification = new Notification(R.drawable.ic_launcher, "Nomal Notification", System.currentTimeMillis());
        
        // flag մϴ
        // FLAG_AUTO_CANCEL : ˸(ġϸ ), FLAG_ONGOING_EVENT : (Լ ǥ)
        notification.flags = Notification.FLAG_AUTO_CANCEL;
        
        // Sdcard ִ Ҹ ϰų assets  Ҽ ֽϴ
//        notification.sound = Uri.parse("file:///sdcard/media/gogosing.mp3");
        
        // Ҹ  մϴ
        notification.defaults = Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE ;
        
        notification.number = 13;
        
        // ˸ 켱 մϴ API 16 밡մϴ (Added in API level 16)
//        notification.priority = Notification.PRIORITY_DEFAULT;
        
        // MainActivity.class ˸ ġϸ ̵ ƼƼԴϴ
        // PendingIntent ؼ   ˴ϴ
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), PendingIntent.FLAG_UPDATE_CURRENT);
        
        // ù° Context, ι° °    ϴ
        notification.setLatestEventInfo(this, "Nomal Title", "Nomal Summary", pendingIntent);
        
        // 1234 ˸  Դϴ ˸ ﶩ nm.cancel(1234)  ֽϴ
        nm.notify(1234, notification);
    }
    
    public void NotificationBuilder(View v){
        /**
         * FLAG_CANCEL_CURRENT :   PendingIntent  ϰ Ӱ .
         * FLAG_NO_CREATE :  PendingIntent ȯѴ.  ϴ.
         * FLAG_ONE_SHOT :  flag   PendingIntent  ȸ̴.
         * FLAG_UPDATE_CURRENT : ̹  PendingIntent  ϸ ش Intent   Ѵ.
         */
        NotificationManager nm = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), PendingIntent.FLAG_UPDATE_CURRENT);
        
        Notification.Builder mBuilder = new Notification.Builder(this);
        mBuilder.setSmallIcon(R.drawable.ic_launcher);
        mBuilder.setTicker("Notification.Builder");
        mBuilder.setWhen(System.currentTimeMillis());
        mBuilder.setNumber(10);
        mBuilder.setContentTitle("Notification.Builder Title");
        mBuilder.setContentText("Notification.Builder Massage");
        mBuilder.setDefaults(Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE);
        // mBuilder.setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION));
        mBuilder.setContentIntent(pendingIntent);
        mBuilder.setAutoCancel(true);
        
        mBuilder.setPriority(NotificationCompat.PRIORITY_MAX);
        
        nm.notify(111, mBuilder.build());
    }

    public void NotificationCompatBuilder(View v){
        NotificationManager nm = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), PendingIntent.FLAG_UPDATE_CURRENT);
        
        NotificationCompat.Builder mCompatBuilder = new NotificationCompat.Builder(this);
        mCompatBuilder.setSmallIcon(R.drawable.ic_launcher);
        mCompatBuilder.setTicker("NotificationCompat.Builder");
        mCompatBuilder.setWhen(System.currentTimeMillis());
        mCompatBuilder.setNumber(10);
        mCompatBuilder.setContentTitle("NotificationCompat.Builder Title");
        mCompatBuilder.setContentText("NotificationCompat.Builder Massage");
        mCompatBuilder.setDefaults(Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE);
        mCompatBuilder.setContentIntent(pendingIntent);
        mCompatBuilder.setAutoCancel(true);
        
        nm.notify(222, mCompatBuilder.build());
    }
    
    
    public void bigPicture(View v){
        NotificationManager nm = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), PendingIntent.FLAG_UPDATE_CURRENT);
        
        Bitmap bigPicture = BitmapFactory.decodeResource(getResources(), R.drawable.jellybean);
        
        Notification.Builder mBuilder = new Notification.Builder(this);
        mBuilder.setSmallIcon(R.drawable.ic_launcher);
        mBuilder.setTicker("Notification.Builder bigPicture");
        mBuilder.setWhen(System.currentTimeMillis());
        mBuilder.setNumber(10);
        mBuilder.setContentTitle("bigPicture Title");
        mBuilder.setContentText("bigPicture Massage");
        mBuilder.setDefaults(Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE);
        mBuilder.setContentIntent(pendingIntent);
        mBuilder.setAutoCancel(true);
        mBuilder.addAction(R.drawable.ic_launcher, "Send Message", pendingIntent);
        
        Notification.BigPictureStyle bigStyle = new BigPictureStyle(mBuilder);
        bigStyle.setBigContentTitle("bigpicture Expanded Title");
        bigStyle.setSummaryText("bigpicture Expanded Massage");
        bigStyle.bigPicture(bigPicture);
        
        mBuilder.setStyle(bigStyle);
        
        nm.notify(333, mBuilder.build());
    }
    
    public void bigTextStyle(View v){
        NotificationManager nm = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), 0);
        
        Notification.Builder mBuilder = new Notification.Builder(this);
        mBuilder.setSmallIcon(R.drawable.ic_launcher);
        mBuilder.setTicker("Notification.Builder bigText");
        mBuilder.setWhen(System.currentTimeMillis());
        mBuilder.setNumber(10);
        mBuilder.setContentTitle("bigText Title");
        mBuilder.setContentText("bigText Message");
        mBuilder.setDefaults(Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE);
        mBuilder.setContentIntent(pendingIntent);
        mBuilder.setAutoCancel(true);
        
        Notification.BigTextStyle style = new Notification.BigTextStyle(mBuilder);
        style.setSummaryText("and More +");
        style.setBigContentTitle("BigText Expanded Title");
        style.bigText("Mir's IT Blog adress is \"whdghks913.tistory.com\"," +
        		"Welcome to the Mir's Blog!! Nice to Meet you, this is Example JellyBean Notification");
        
        mBuilder.setStyle(style);
        
        nm.notify(444, mBuilder.build());
    }
    
    public void InboxStyle(View v){
        NotificationManager nm = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), 0);
        
        Notification.Builder mBuilder = new Notification.Builder(this);
        mBuilder.setSmallIcon(R.drawable.ic_launcher);
        mBuilder.setTicker("Notification.Builder InboxStyle");
        mBuilder.setWhen(System.currentTimeMillis());
        mBuilder.setNumber(10);
        mBuilder.setContentTitle("InboxStyle Title");
        mBuilder.setContentText("InboxStyle Message");
        mBuilder.setDefaults(Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE);
        mBuilder.setContentIntent(pendingIntent);
        mBuilder.setAutoCancel(true);
        
        Notification.InboxStyle style = new InboxStyle(mBuilder);
        style.addLine("Google Nexus 5 is $0!!");
        style.addLine("Example Nofitication Inbox");
        style.addLine("Today is 2014-01-29");
        style.addLine("See you Next Time!");
        style.setSummaryText("+ 3 More");
        
        mBuilder.setStyle(style);
        
        nm.notify(555, mBuilder.build());
    }
    
    public void ProgressBar_ICS(View v){
        final NotificationManager nm = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), 0);
        
        Bitmap bigPicture = BitmapFactory.decodeResource(getResources(), R.drawable.jellybean);
        
        final Notification.Builder mBuilder = new Notification.Builder(this);
        mBuilder.setSmallIcon(R.drawable.ic_launcher);
        mBuilder.setTicker("Notification.Builder ProgressBar");
        mBuilder.setWhen(System.currentTimeMillis());
        mBuilder.setNumber(10);
        mBuilder.setContentTitle("ProgressBar Title");
        mBuilder.setContentText("ProgressBar Message");
        
        mBuilder.setProgress(0, 0, true);
        mBuilder.setContentText("Please a secound");
        mBuilder.setContentIntent(pendingIntent);
        mBuilder.setOngoing(true);
        
        Notification.BigPictureStyle bigStyle = new BigPictureStyle(mBuilder);
        bigStyle.bigPicture(bigPicture);
        
        mBuilder.setStyle(bigStyle);
        
        
        nm.notify(666, mBuilder.build());
        
        new Thread(new Runnable() {
            @Override
            public void run() {
                for(int i=1 ;i<=100 ;i++){
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    
                    mBuilder.setProgress(100, i, false);
                    mBuilder.setContentText("ProgressBar : " + i);
                    nm.notify(666, mBuilder.build());
                    
                    if(i>=100){
                        nm.cancel(666);
                    }
                }
            }
        }).start();
        
    }
    
    @SuppressWarnings("deprecation")
    public void ProgressBar_GB(View v){
        final NotificationManager nm = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
        final PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, MainActivity.class), 0);
        
        new Thread(new Runnable() {
			@Override
            public void run() {
                RemoteViews mRemoteView = new RemoteViews(getPackageName(), R.layout.progressbar);
                mRemoteView.setTextViewText(R.id.noti_title, "GB ProgressBar");
                mRemoteView.setProgressBar(R.id.noti_progress, 100, 0, false);
                
                Notification notification = new Notification(R.drawable.ic_launcher, "ProgressBar GB", System.currentTimeMillis());
                notification.flags |= Notification.FLAG_ONGOING_EVENT;
                notification.contentIntent = pendingIntent;
                notification.contentView = mRemoteView;
                
                notification.contentView.setProgressBar(R.id.noti_progress, 0, 0, true);
                nm.notify(777, notification);
                
                for(int i=0 ;i<=100 ;i++){
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    notification.contentView.setProgressBar(R.id.noti_progress, 100, i, false);
                    notification.contentView.setTextViewText(R.id.noti_text, "Progress : "+i);
                    nm.notify(777, notification);
                    
                    if(i>=100){
                        nm.cancel(777);
                    }
                }
            }
        }).start();
    }
}
